(function (sequelize, $, undefined) {

    sequelize.Service = function (options, $rootScope, $q, $http, $io) {

        options = $.extend(options, {
            baseUrl: '/api'
        });

        var _models = [];

        Object.defineProperty(this, 'models', {
            get: function () {
                return _models
            }
        })

        this.sync = function () {

            $http.get(options.baseUrl).then(

                function (models) {

                    models.data.data.forEach(function (model) {

                        $http.head(options.baseUrl + '/' + model.name).then(

                            function (result) {

                                var model = result.headers('Sequelize-Admin');
                                model = JSON.parse(model);
                                model = new sequelize.Model(model.data, $rootScope, $q, $http, $io);
                                _models.push(model);

                                model.sync();
                            },
                            function (error) {
                                console.log(error);
                            }
                        )
                    });
                },
                function (error) {
                    console.log(error);
                }
            );
        }
    }

}(window.sequelize = window.sequelize || {}, jQuery));